//
// gpsr_receiver.hh : GPSR Receiver Include File
// author           : Xi Wang
// note             : Converted from ping_receiver
//
// Copyright (C) 2000-2003 by the University of Southern California
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License,
// version 2, as published by the Free Software Foundation.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License along
// with this program; if not, write to the Free Software Foundation, Inc.,
// 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.
//
//

#ifndef _GPSR_RECEIVER_HH_
#define _GPSR_RECEIVER_HH_

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif // HAVE_CONFIG_H

#include "diffapp.hh"

#include "gpsr_attrs.hh"

class GPSRReceiverReceive;

class GPSRReceiverApp : public DiffApp {
public:
#ifdef NS_DIFFUSION
  GPSRReceiverApp();
  int command(int argc, const char*const* argv);
#else
  GPSRReceiverApp(int argc, char **argv);
#endif // NS_DIFFUSION

  void recv(NRAttrVec *data, NR::handle my_handle);
  void run();

  double my_x, my_y;
  int trace_en;
  int my_id_;

private:
  // NR Specific variables
  GPSRReceiverReceive *mr_;
  handle subHandle_;

  // GPSR App variables
  int last_seq_recv_;
  int num_msg_recv_;
  int first_msg_recv_;

  handle setupSubscription();
};

class GPSRReceiverReceive : public NR::Callback {
public:
  GPSRReceiverReceive(GPSRReceiverApp *app) : app_(app) {};
  void recv(NRAttrVec *data, NR::handle my_handle);

  GPSRReceiverApp *app_;
};

#endif // !_GPSR_RECEIVER_HH_
