//
// rbp_receiver.hh : Rbp Receiver Include File
// author          : Fred Stann
//

#ifndef _RBP_RECEIVER_HH_
#define _RBP_RECEIVER_HH_

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif // HAVE_CONFIG_H

#include "rbp_common.hh"

class RbpReceiverReceive;

class RbpReceiverApp : public DiffApp {
public:
  RbpReceiverApp(int argc, char **argv);

  void recv(NRAttrVec *data, NR::handle my_handle);
  void run();

private:
  // NR Specific variables
  RbpReceiverReceive *mr_;
  handle subHandle_;
  struct timeval startTime_;

  handle setupSubscription();
};

class RbpReceiverReceive : public NR::Callback {
public:
  RbpReceiverReceive(RbpReceiverApp *app) : app_(app) {};
  void recv(NRAttrVec *data, NR::handle my_handle);

  RbpReceiverApp *app_;
};

#endif // !_RBP_RECEIVER_HH_
