//
// rbp_sender.hh : Rbp Sender Include File
// author        : Fred Stann
//

#ifndef _RBP_SENDER_HH_
#define _RBP_SENDER_HH_

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif // HAVE_CONFIG_H

#include "rbp_common.hh"

class RbpSenderReceive;
class RbpSenderApp;

#define SEND_DATA_INTERVAL 20

class RbpSenderApp : public DiffApp {
public:
  RbpSenderApp(int argc, char **argv);
  virtual ~RbpSenderApp()
  {
    // Nothing to do
  };

  void run();
  void recv(NRAttrVec *data, NR::handle my_handle);

private:
  // NR Specific variables
  RbpSenderReceive *mr_;
  handle subHandle_;
  handle pubHandle_;

  // Rbp App variables
  int num_subscriptions_;
  int last_seq_sent_;
  int source_id_;
  NRAttrVec data_attr_;
  NRSimpleAttribute<int> *sourceIDAttr_;
  NRSimpleAttribute<int> *counterAttr_;

  handle setupPublication();
  handle setupSubscription();
};

class RbpSenderReceive : public NR::Callback {
public:
  RbpSenderReceive(RbpSenderApp *app) : app_(app) {};
  void recv(NRAttrVec *data, NR::handle my_handle);
  RbpSenderApp *app_;
};

#endif // !_RBP_SENDER_HH_
